unit Events;

interface

	uses
		QDOffscreen, Globals, Graphics, Menus, Windows;

{----------------------------}

	procedure HandleEvent (theEvent: EventRecord);

{----------------------------}

implementation

{----------------------------}

	procedure HandleEvent (theEvent: EventRecord);

		var
			theChar: char;
			extended: boolean;

	begin
		case theEvent.what of
			mouseDown: 
				case FindWindow(theEvent.where, appGlobals.whichWindow) of
					inSysWindow: 
						SystemClick(theEvent, appGlobals.whichWindow);

					inMenuBar: 
						DoCommand(MenuSelect(theEvent.where));

					inDrag: 
						DragWindow(appGlobals.whichWindow, theEvent.where, gameScreen.dragRect);

					inContent: 
						begin
							if appGlobals.whichWindow <> FrontWindow then
								SelectWindow(appGlobals.whichWindow)
							else
								begin
									GlobalToLocal(theEvent.where);
									extended := BitAnd(theEvent.modifiers, shiftKey) <> 0;
								end;
						end;

					otherwise
				end;

			keyDown, autoKey: 
				begin
					theChar := chr(BitAnd(theEvent.message, charCodeMask));
					if BitAnd(theEvent.modifiers, cmdKey) <> 0 then
						DoCommand(MenuKey(theChar))
					else
						begin
							case theChar of
								'w', 'W', 'i', 'I': 
									pacmanInfo.direction := Up;
								'a', 'A', 'j', 'J': 
									pacmanInfo.direction := Left;
								's', 'S', 'k', 'K': 
									pacmanInfo.direction := Down;
								'd', 'D', 'l', 'L': 
									pacmanInfo.direction := Right;
								otherwise
									;
							end;
						end;
				end;

			activateEvt: 
				begin
					if BitAnd(theEvent.modifiers, activeFlag) <> 0 then
						begin
							DisableItem(gameMenus.menusArray[editM], undoCommand);
						end
					else
						begin
							EnableItem(gameMenus.menusArray[editM], undoCommand);
						end;
				end;

			updateEvt: 
				begin
					BeginUpdate(WindowPtr(theEvent.message));
					DrawScreen(true);
					EndUpdate(WindowPtr(theEvent.message));
				end;

			otherwise
		end;
	end;

{----------------------------}

end.