unit Game;

interface

	uses
		QDOffscreen, Globals;

{----------------------------}

	procedure SetupGameGlobals;
	procedure SetNewPosition (who: Names);
	procedure CollisionHandler;

{----------------------------}

implementation

{----------------------------}

	procedure SetupGameGlobals;

	begin
		case gameMenus.windowSelection of
			Small: 
				begin
					gameGlobals.borderLeft := 128;
					gameGlobals.borderTop := 8;
					gameGlobals.borderRight := 369;
					gameGlobals.borderBottom := 278;
{         gameGlobals.incrementSize := 3;6 sound clicks}
					gameGlobals.incrementSize := 2;{9 sound clicks}
					pacmanInfo.direction := Left;
					pacmanInfo.frameNo := 0;
					pacmanInfo.positionLeft := 248;
					pacmanInfo.positionTop := 220;
				end;

			Medium: 
				begin
					gameGlobals.borderLeft := 130;
					gameGlobals.borderTop := 10;
					gameGlobals.borderRight := 482;
					gameGlobals.borderBottom := 402;
{         gameGlobals.incrementSize := 5;7 sound clicks}
					gameGlobals.incrementSize := 4;{9 sound clicks}
					pacmanInfo.direction := Left;
					pacmanInfo.frameNo := 0;
					pacmanInfo.positionLeft := 308;
					pacmanInfo.positionTop := 319;
				end;

			Large: 
				begin
					gameGlobals.borderLeft := 200;
					gameGlobals.borderTop := 15;
					gameGlobals.borderRight := 780;
					gameGlobals.borderBottom := 665;
{         gameGlobals.incrementSize := 10;12 sound clicks}
					gameGlobals.incrementSize := 13;{9 sound clicks}
					pacmanInfo.direction := Left;
					pacmanInfo.frameNo := 0;
					pacmanInfo.positionLeft := 492;
					pacmanInfo.positionTop := 526;
				end;

			otherwise
				;
		end;
	end;

{----------------------------}

	procedure SetNewPosition (who: Names);

	begin
		case who of

			PacMan: 
				begin
					with pacmanInfo do
						begin
							case direction of

								Left: 
									begin
										incrementX := gameGlobals.incrementSize * (-1);
										incrementY := 0;
										positionLeft := positionLeft + incrementX;
										positionTop := positionTop + incrementY;
										if positionLeft < gameGlobals.borderLeft then
											begin
												positionLeft := gameGlobals.borderLeft;
												direction := Right;
												frameNo := 0;
											end;
									end;

								Up: 
									begin
										incrementX := 0;
										incrementY := gameGlobals.incrementSize * (-1);
										positionLeft := positionLeft + incrementX;
										positionTop := positionTop + incrementY;
										if positionTop < gameGlobals.borderTop then
											begin
												positionTop := gameGlobals.borderTop;
												direction := Down;
												frameNo := 0;
											end;
									end;

								Right: 
									begin
										incrementX := gameGlobals.incrementSize;
										incrementY := 0;
										positionLeft := positionLeft + incrementX;
										positionTop := positionTop + incrementY;
										if positionLeft > gameGlobals.borderRight then
											begin
												positionLeft := gameGlobals.borderRight;
												direction := Left;
												frameNo := 0;
											end;
									end;

								Down: 
									begin
										incrementX := 0;
										incrementY := gameGlobals.incrementSize;
										positionLeft := positionLeft + incrementX;
										positionTop := positionTop + incrementY;
										if positionTop > gameGlobals.borderBottom then
											begin
												positionTop := gameGlobals.borderBottom;
												direction := Up;
												frameNo := 0;
											end;
									end;

								otherwise
									;
							end;

							SetRect(pictRect, positionLeft, positionTop, positionLeft + pictSize, positionTop + pictSize);
						end;
				end;


			otherwise
				;
		end;
	end;

{----------------------------}

	procedure CollisionHandler;

		var
			index: integer;
			collisionFlag, testResult: boolean;
			pacmanRect, pelletRect, intersectionRect: Rect;

	begin
		pacmanRect := pacmanInfo.pictRect;

		with pelletInfo do
			begin
				collisionFlag := false;
				for index := 0 to 25 do
					begin
						pelletRect := pelletInfo.pelletRectArrayH[index];
						testResult := SectRect(pacmanRect, pelletRect, intersectionRect);
						if testResult then
							begin
								collisionFlag := true;
								gameGlobals.pelletsConsumed := gameGlobals.pelletsConsumed + 1;
								FillRect(pelletRect, black);
								SetRect(pelletInfo.pelletRectArrayH[index], 0, 0, 0, 0);
							end;
					end;

				for index := 0 to 25 do
					begin
						pelletRect := pelletInfo.pelletRectArrayV[index];
						testResult := SectRect(pacmanRect, pelletRect, intersectionRect);
						if testResult then
							begin
								collisionFlag := true;
								gameGlobals.pelletsConsumed := gameGlobals.pelletsConsumed + 1;
								FillRect(pelletRect, black);
								SetRect(pelletInfo.pelletRectArrayV[index], 0, 0, 0, 0);
							end;
					end;

			end;
	end;

{----------------------------}

end.