unit Globals;

interface

	uses
		QDOffscreen;

	const
		bytesPerPixel = 4;

		appleID = 128;
		fileID = 129;
		editID = 130;
		windowID = 131;

		noMenuID = 0;
		appleM = 1;
		fileM = 2;
		editM = 3;
		windowM = 4;

		menuCount = 4;

		alertDialogID = 128;

		smallWindowID = 128;
		mediumWindowID = 129;
		largeWindowID = 130;

		backdropSmallBwPictID = 128;
		backdropSmallColorPictID = 129;
		backdropMediumColorPictID = 130;
		backdropLargeColorPictID = 131;

		smallPacman_solid = 132;
		mediumPacman_solid = 141;
		largePacman_solid = 150;

		smallPellet = 161;
		mediumPellet = 160;
		largePellet = 159;

		undoCommand = 1;
		cutCommand = 3;
		copyCommand = 4;
		pasteCommand = 5;
		clearCommand = 6;

		smallCommand = 1;
		mediumCommand = 2;
		largeCommand = 3;
		developerViewCommand = 5;

	type
		Sizes = (Small, Medium, Large);
		Directions = (Left, Up, Right, Down);
		Names = (PacMan, Monstr1);

		AppGlobalsRecord = record
				whichWindow: WindowPtr;
				whichEvent: EventRecord;
				doneFlag: boolean;
				lastDrawTick, drawCycles, avgDrawCycles: longint;
			end;

		GameGlobalsRecord = record
				borderLeft, borderTop, borderRight, borderBottom: integer;
				incrementSize: integer;
				pelletsConsumed: integer;
			end;

		AppScreenRecord = record
				screenRect, dragRect: Rect;
				resolution: record
						hRes, vRes: integer;
					end;
				gameGrafPtr, offScreenGrafPtr: GrafPtr;
			end;

		AppMenusRecord = record
				menusArray: array[1..menuCount] of MenuHandle;
				windowSelection: Sizes;
				developerViewFlag: boolean;
			end;

		AppWindowRecord = record
				windowPtr: WindowPtr;
				cWindowPtr: CWindowPtr;
				offGWorld: GWorldPtr;
				windowRecord: WindowRecord;
				windowRect: Rect;
				width, height: integer;
			end;

		BackgroundImageRecord = record
				pictH: PicHandle;
				pictRect: Rect;
				pictWidth, pictHeight, pictLeft, pictTop: integer;
			end;

		CharacterImageRecord = record
				pictH: PicHandle;
			end;

		PelletImageRecord = record
				pictH: PicHandle;
			end;

		CharacterInfoRecord = record
				pictArray: array[1..9] of CharacterImageRecord;
				pictSize: integer;
				pictRect, previousRect: Rect;
				positionLeft, positionTop: integer;
				frameNo: integer;
				incrementX, incrementY: integer;
				direction: Directions;
			end;

		PelletInfoRecord = record
				pelletRectArrayH: array[0..25] of Rect;
				pelletRectArrayV: array[0..25] of Rect;
				pictImage: PelletImageRecord;
				pictSize: integer;
			end;

	var
		gHasGestalt, gColorQdAvailable: Boolean;
		gQuickdrawVersion: longint;

		appGlobals: AppGlobalsRecord;
		gameGlobals: GameGlobalsRecord;
		gameScreen: AppScreenRecord;
		gameMenus: AppMenusRecord;
		gameWindow: AppWindowRecord;
		backgroundPict: BackgroundImageRecord;
		pacmanInfo: CharacterInfoRecord;
		pelletInfo: PelletInfoRecord;

{----------------------------}

implementation

{----------------------------}

end.