unit Windows;

interface

	uses
		QDOffscreen, Globals, Graphics, Dialogs;

{----------------------------}

	procedure SetUpScreen;
	procedure SetUpWindow;

{----------------------------}

implementation

	procedure SetUpScreen;

	begin
		with gameScreen do
			begin
				ScreenRes(gameScreen.resolution.hRes, gameScreen.resolution.vRes);
				screenRect := screenBits.bounds;
				with screenBits.bounds do
					SetRect(dragRect, 4, 24, right - 4, bottom - 4);
			end;

{ default window sizing }
		if gColorQdAvailable then
			gameMenus.windowSelection := Medium
		else
			gameMenus.windowSelection := Small;
	end;

{----------------------------}

	procedure SetUpWindow;

	begin
		with gameWindow do
			begin
				if gameMenus.windowSelection = Small then
					begin
						windowPtr := GetNewWindow(smallWindowID, @windowRecord, pointer(-1));
						SetPort(windowPtr);
					end
				else if gameMenus.windowSelection = Medium then
					begin
						windowPtr := GetNewCWindow(mediumWindowID, @windowRecord, pointer(-1));
						cWindowPtr := Pointer(windowPtr);
						SetPort(windowPtr);
					end
				else if gameMenus.windowSelection = Large then
					begin
						windowPtr := GetNewCWindow(largeWindowID, @windowRecord, pointer(-1));
						cWindowPtr := Pointer(windowPtr);
						SetPort(windowPtr);
					end
				else
					AlertWithMessage('Error - (SetUpWindow) Invalid windowSelection');

				windowRect := windowPtr^.portRect;
				width := windowRect.right - windowRect.left;
				height := windowRect.bottom - windowRect.top;
			end;

		InitGraphics;
	end;

{----------------------------}

end.